import java.util.ArrayList;
import java.util.Iterator;
import java.util.Random;

/* Classe qui gre la bibliotheque
 * */
public class Bibliotheque {

	static ArrayList<Ouvrage> Ouvrages = new ArrayList<Ouvrage>();
	static ArrayList<Demande> Demandes = new ArrayList<Demande>();

	/**
	 * Simulation bibliotheque
	 * */
	static void run_bibliotheque() {
		int time = 0; // heures de fonctionement de la bibliotheque

		while (Demandes.size() > 0) {
			System.out.println(time + "h");

			// Dangereux de supprimer d'une liste lorsque on la traverse.
			// Iterator et Iterator.remove() assure c'est fait correctement.
			for (Iterator<Demande> itd = Demandes.iterator(); itd.hasNext();) {
				Demande d = (Demande) itd.next();
				// objet directement aprs la position indiqu par l'Iterator

				System.out.print("D" + d.getDemandeNo() + " ");

				for (Ouvrage o : Ouvrages) {
					o.update(time); // mettre  jour l'tat d'ouvrage
					if (d.getID() == o.getID()) {
						if (o.acces(d.getTime()))
							itd.remove();
					}
				}
			}
			++time;
		}

	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Random randomGenerator = new Random();
		int id_counter = 0;

		// ajouter 4 ouvrages avec ID 0-3
		Ouvrages.add(new Papier(id_counter, "Alice's Adventures in Wonderland",
				"2012", "ISDN:...", "Louis Carrol", "Penguin"));
		Ouvrages.add(new PapierRare(++id_counter,
				"Alice's Adventures in Wonderland", "1865", "ISDN:...",
				"Louis Carrol", "Macmillan"));
		Ouvrages.add(new PapierRare(++id_counter, "En Attendant Godot", "1952",
				"ISDN:...", "Samuel Beckett", "French & European"));
		Ouvrages.add(new Papier(++id_counter,
				"Harry Potter and the Prisoner of Azkaban", "1999", "ISDN:...",
				"J. K. Rowling", "Bloomsbury"));

		System.out.println("Ouvrages: " + Ouvrages.size());

		// ajouter 20 demandes pour les ouvrages d'ID 0-id_counter
		for (int d = 0; d < 20; ++d) {
			int d_ID = randomGenerator.nextInt(id_counter + 1);
			int d_time = randomGenerator.nextInt(120);
			Demandes.add(new Demande(d, d_ID, d_time));
		}
		System.out.println("Demandes: " + Demandes.size());

		run_bibliotheque();
	}
}
