/**
 * @author anab
 * 
 */
public class ElectroniqueRare extends Electronique implements Rare {

	public ElectroniqueRare(int ID, String titre, String dateDePublication,
			String label) {
		super(ID, titre, dateDePublication, label);
	}

	/**
	 * acces sur place pour 24h ou moins
	 * 
	 * @param t
	 *            demander access pour temps t, toujours moins de 24h
	 * */
	@Override
	public void accederSurPlace(int t) {
		System.out.println("[ElecRare]" + ID + " " + titre
				+ " est accessible seulement sur place pour 24 heures");
	}

	/**
	 * Donner acces sur place pour 24h, meme si on demande plus
	 * 
	 * @param t
	 *            demander access pour temps t
	 * @return vraie si l'ouvrage Electronique Rare est disponible, sinon false
	 * */
	@Override
	public boolean acces(int t) {
		if (disponible) {
			if (t > 24)
				t = 24;
			tempsPourDevenirDisponible = t;
			disponible = false;
			accederSurPlace(t);
			return true;
		}
		System.out.println("[ElecRare]" + ID + " " + titre
				+ " n'est pas disponible, essayer plus tard");
		return false;
	}

}
