/**
 * @author anab
 * 
 */
public class PapierRare extends Papier implements Rare {

	public PapierRare(int ID, String titre, String dateDePublication,
			String ISDN, String auteur, String maisonImprimerie) {
		super(ID, titre, dateDePublication, ISDN, auteur, maisonImprimerie);
	}

	/**
	 * acces sur place pour 24h ou moins
	 * 
	 * @param t
	 *            demander access pour temps t, toujours moins de 24h
	 * */
	@Override
	public void accederSurPlace(int t) {
		System.out.println("[PapierRare]" + ID + " " + titre
				+ " est accessible seulement sur place pour 24 heures");
	}

	/**
	 * Donner acces sur place pour 24h, meme si on demande plus
	 * 
	 * @param t
	 *            demander access pour temps t
	 * @return vraie si l'ouvrage Papier Rare est disponible, sinon false
	 * */

	@Override
	public boolean acces(int t) {
		if (disponible) {
			tempsPourDevenirDisponible = 24;
			disponible = false;
			accederSurPlace(t);
			return true;
		}
		System.out.println("[PapierRare]" + ID + " " + titre
				+ " n'est pas disponible, essayer plus tard");
		return false;
	}

}
